"""
Copyright by 3Deoskill.com
Author:
Thomas Bösl
Am Stadtpark 22
09120 Chemnitz
Germany
3deoskill.com
mail: info@3deoskill.com
"""


import c4d
from c4d import utils
import math

def main():
    op=doc.GetActiveObject()
    #i=op.GetAllPolygons()
    #i=op.GetPolygonCount()
    vec_sum=0
    if op!=None:
        if  bool(op.GetInfo() & c4d.OBJECT_POLYGONOBJECT):
            selection=op.GetPolygonS()
            
            
            p1=c4d.Vector()
            if selection.GetCount()==0:
                selection.SelectAll(op.GetPolygonCount(),0,0)




            index=[]
            for i in range(0,op.GetPolygonCount()):
                if selection.IsSelected(i):
                    index.append(i)


            for count in index:
                poly=op.GetPolygon(count)
                if c4d.CPolygon.IsTriangle(poly)==True:

                    #=========================Berechnung Dreiecksfläche
                    p1=op.GetPoint(poly.a)
                    p3=op.GetPoint(poly.b)
                    p2=op.GetPoint(poly.c)


                    v1=p2-p1
                    v2=p3-p1

                    #=====Kreuzprodukt================================

                    vec_cross=v1%v2

                    #=====VectorDotProdukt==============================
                    vec_sum=vec_sum + ((math.sqrt(vec_cross.GetLengthSquared()))/2)



                elif c4d.CPolygon.IsTriangle(poly)==False:

                    #=========================Berechnung Dreiecksfläche
                    p1=op.GetPoint(poly.a)  #Koordinaten Vertex
                    p3=op.GetPoint(poly.b)
                    p4=op.GetPoint(poly.c)
                    p2=op.GetPoint(poly.d)


                    v1=p2-p1                #Richtungsvektor
                    v2=p3-p1

                    v3=p2-p3
                    v4=p4-p3

                    #=====Kreuzprodukt===============================

                    vec_cross=v1%v2
                    vec_cross2=v3%v4

                    #=====VectorDotProdukt Fläche=====================
                    vec_sum=vec_sum + ((math.sqrt(vec_cross.GetLengthSquared()))/2)
                    vec_sum=vec_sum + ((math.sqrt(vec_cross2.GetLengthSquared()))/2)


            #======================Text-Creation======================


            text=c4d.BaseObject(c4d.Osplinetext)


            text[c4d.ID_BASELIST_NAME]="CSurfaceText"
            text[c4d.PRIM_TEXT_HEIGHT]=50
            text[c4d.PRIM_TEXT_ALIGN]=1
            text.SetAbsPos(p1)
            doc.InsertObject(text)

            normal_vec=-1*(op.CreatePhongNormals()[0])

            text.SetAbsRot(utils.VectorToHPB(normal_vec))

            #=====================Output=======================================
            text[c4d.PRIM_TEXT_TEXT]=str(round(vec_sum/10000,2))+" m²"
            doc.SetActiveObject(text)

            c4d.EventAdd()

        else:
            c4d.gui.MessageDialog("Object has to be a polygon object!")
    else:
        c4d.gui.MessageDialog("No object selected!")










# Execute main()
if __name__=='__main__':
    main()